=== debian/changelog ===
bart (0.4.04-2) unstable; urgency=medium

  * Add some fixes from upstream.
  * Deactivate unit tests for ODE solver.
  * Deactivate unit tests for some archs.
  * Add autopkgtest for octave interface script.

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Tue, 11 Dec 2018 13:07:12 +0100

bart (0.4.04-1) unstable; urgency=medium

  * New upstream version.
  * Relax error bound for new unit test.
  * Standards-Version: 4.2.1

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Mon, 10 Dec 2018 14:32:26 +0100
