=== debian/tests/control ===
Test-Command: /usr/bin/bart version
Depends: bart

Tests: octave-integration
Depends: octave-bart, octave
