=== debian/changelog ===
bart (0.5.00-1) unstable; urgency=medium

  [ Martin Uecker ]
  * New upstream version.
  * Standards-Version: 4.4.0

  [ Andreas Tille ]
  * debhelper-compat 12
  * Remove trailing whitespace in debian/copyright

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Tue, 27 Aug 2019 14:18:12 +0200
